import sys
import time
import MySQLdb
import traceback

class dbwriter:
    def __init__(self,addr):
        self.db = False
        self.address = addr

    def Connect(self):
        try:
            print "Connecting to MySQL Database..."
            bits = self.address.split(':')

            self.database = bits[3]
            self.table = bits[5]
            self.lookup = bits[6]
            self.stamp = bits[7]
            self.value = bits[8]
            self.db = MySQLdb.connect(bits[0],bits[3],bits[4],bits[2],port=int(bits[1]))
            print "Connection Successful!"
            return True
        except:
            traceback.print_exc()
            return False

    def Prepare(self,channels):
        self.lookups = False

        tableexists = False
        try:
            cursor = self.db.cursor()

            cursor.execute("SELECT table_name FROM information_schema.tables WHERE table_schema = '" + self.database + "' AND table_name = '" + self.table + "'")
            results = cursor.fetchall()
            if len(results) > 0:
                tableexists = True
            else:
                try:
                    #Prepare Tables
                    cursor.execute('CREATE TABLE IF NOT EXISTS `' + self.table + '_data` (measurement bigint(20) NOT NULL,stamp datetime NOT NULL,value double NOT NULL) ENGINE=InnoDB DEFAULT CHARSET=latin1');
                    
                    cursor.execute('CREATE TABLE IF NOT EXISTS `' + self.table + '_lookup` (`name` varchar(80) NOT NULL,`id` bigint(20) NOT NULL AUTO_INCREMENT,PRIMARY KEY (`id`)) ENGINE=InnoDB  DEFAULT CHARSET=utf8 AUTO_INCREMENT=1');
                    
                    cursor.execute('CREATE OR REPLACE VIEW ' + self.table+ ' AS select ' + self.table + '_lookup`.`name` AS `' + self.lookup + '`,`' + self.table + '_data`.`stamp` AS `' + self.stamp + '`,`' + self.table + '_data`.`value` AS `' + self.value + '` from (`' + self.table + '_lookup` join `' + self.table + '_data` on((`' + self.table + '_data`.`measurement` = `' + self.table + '_lookup`.`id`))')
                except:
                    pass
        try:
            cursor = self.db.cursor()

            cursor.execute("SELECT name,id FROM " + self.table + "_lookup")
            results = cursor.fetchall()
            self.lutable = {}
            for r in results:
                self.lutable[r[0]] = r[1]

            #OK - we've loaded all of the existing lookups!

            #Are any missing?
            syncer = ""
            
            for v in channels:
                if v.field not in self.lutable:
                    if (syncer != ""):
                        syncer += ","
                    syncer += "('" + self.db.escape_string(v.field) + "')"

            if syncer != "":

                qry = "INSERT INTO " + self.table + "_lookup (name) VALUES " + syncer
                print qry
                self.db.query(qry)
                self.db.commit()
                #print "Updating Lookup Table With New Options"
                cursor = self.db.cursor()
                cursor.execute("SELECT name,id FROM " + self.table + "_lookup")
                results = cursor.fetchall()
                self.lutable = {}
                for r in results:
                    self.lutable[r[0]] = r[1]

            self.lookups = True
            self.table = self.table
            print "Lookup Found!"

            #print str(self.lutable)
        except:
            traceback.print_exc()
            print "No Lookups Found!"
            pass

    def WriteImage(self,image):
        
        if len(image) == 0:
            return
        try:
            if self.lookups == False:
                qry = "INSERT INTO " + self.table +" (" + self.lookup + ", " + self.value+ "," + self.stamp + ") VALUES "
            else:
                qry = "INSERT INTO " + self.table +"_data (measurement, value,stamp) VALUES "
            first = True
            for key in image:
                if first == True:
                    first = False
                else:
                    qry += ","
                if self.lookups == True:
                    qry += "(" + str(self.lutable[key]) + ",'" + self.db.escape_string(image[key]) + "',NOW())"
                else:    
                    qry += "('" + self.db.escape_string(key) + "','" + self.db.escape_string(image[key]) + "',NOW())"

            #print qry
            self.db.query(qry)
            self.db.commit()
            #print qry
        except:
            traceback.print_exc()
            self.Connect()
